Name:		gambas
Summary: 	IDE based on a basic interpreter with object extensions
Version: 	1.0.19
Release: 	10%{?dist}
License: 	GPL+
Group: 		Development/Tools
URL: 		http://gambas.sourceforge.net/
Source0: 	http://download.sourceforge.net/%{name}/%{name}-%{version}.tar.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires:	kdelibs3-devel, automake, autoconf, SDL-devel, SDL_mixer-devel
BuildRequires:	mysql-devel, postgresql-devel, sqlite-devel, libX11-devel
BuildRequires:	desktop-file-utils, gettext-devel, curl-devel, libXext-devel
BuildRequires:	qt-devel, bzip2-devel, libxslt-devel, libxml2-devel
Requires(post): desktop-file-utils
Requires(postun): desktop-file-utils
# Code is not 64 bit clean.
# http://sourceforge.net/mailarchive/message.php?msg_id=15024630
ExcludeArch:	x86_64 ppc64
# Code is now endian clean.
# ExcludeArch:	ppc
Patch0:		gambas-1.0.9-gcc4.patch
Patch1:		gambas-1.0.6-dont-make-links.patch
Patch2:		gambas-1.0.6-noopt.patch
Patch3:		gambas-1.0.11-desktopfix.patch
Patch4:		gambas-1.0.13-gettextfix.patch
Patch5:		gambas-1.0.16-64bit.patch

%description
Gambas is a free development environment based on a Basic interpreter
with object extensions, like Visual Basic (but it is NOT a clone !).
With Gambas, you can quickly design your program GUI, access MySQL or
PostgreSQL databases, pilot KDE applications with DCOP, translate your
program into many languages, create network applications easily, and so
on...

%package runtime
Summary:        Runtime environment for gambas
Group:          Development/Tools
Provides:	%{name} = %{version}-%{release}
Obsoletes:	%{name}

%description runtime
Gambas is a free development environment based on a Basic interpreter
with object extensions, like Visual Basic. This package contains the 
runtime components necessary to run programs designed in gambas. 

%package ide
Summary:	Development environment for gambas
Group:		Development/Tools
Requires:	%{name}-runtime = %{version}-%{release}
Requires:	%{name}-gb-compress = %{version}-%{release}
Requires:	%{name}-gb-db = %{version}-%{release}
Requires:	%{name}-gb-debug = %{version}-%{release}
Requires:	%{name}-gb-eval = %{version}-%{release}
Requires:	%{name}-gb-net-curl = %{version}-%{release}
Requires:       %{name}-gb-net = %{version}-%{release}
Requires:       %{name}-gb-qt = %{version}-%{release}
Requires:       %{name}-gb-qt-editor = %{version}-%{release}
Requires:       %{name}-gb-qt-ext = %{version}-%{release}
Requires:       %{name}-gb-qt-kde = %{version}-%{release}
Requires:       %{name}-gb-qt-kde-html = %{version}-%{release}
Requires:       %{name}-gb-sdl = %{version}-%{release}
Requires:       %{name}-gb-vb = %{version}-%{release}
Requires:       %{name}-gb-xml-libxml = %{version}-%{release}
Requires:       %{name}-gb-xml-libxml-rpc = %{version}-%{release}
Requires:       %{name}-gb-xml-libxml-xslt = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{name}-devel, %{name}-help, %{name}-examples
Provides:	%{name}-help = %{version}-%{release}
Provides:	%{name}-examples = %{version}-%{release}

%description ide
The gambas-ide package contains the complete Gambas Development 
Environment, with the database manager, the help files, and all 
components. This is what you want to install if you want to 
create new programs with Gambas.

%package gb-compress
Summary:        Gambas component package for compress
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-compress
%{summary}

%package gb-db
Summary:        Gambas component package for db
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-db
%{summary}

%package gb-debug
Summary:        Gambas component package for debug
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-debug
%{summary}

%package gb-eval
Summary:        Gambas component package for eval
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-eval
%{summary}

%package gb-net
Summary:        Gambas component package for net
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-net
%{summary}

%package gb-net-curl
Summary:        Gambas component package for net.curl
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-net-curl
%{summary}

%package gb-qt
Summary:        Gambas component package for qt
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt
%{summary}

%package gb-qt-editor
Summary:        Gambas component package for qt.editor
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-editor
%{summary}

%package gb-qt-ext
Summary:        Gambas component package for qt.ext
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-ext
%{summary}

%package gb-qt-kde
Summary:        Gambas component package for qt.kde
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-kde
%{summary}

%package gb-qt-kde-html
Summary:        Gambas component package for qt.kde.html
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-qt-kde-html
%{summary}

%package gb-sdl
Summary:        Gambas component package for sdl
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-sdl
%{summary}

%package gb-vb
Summary:        Gambas component package for vb
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-vb
%{summary}

%package gb-xml-libxml
Summary:        Gambas component package for xml.libxml
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-xml-libxml
%{summary}

%package gb-xml-libxml-rpc
Summary:        Gambas component package for xml.libxml.rpc
Group:          Development/Tools
Requires:       %{name}-runtime = %{version}-%{release}

%description gb-xml-libxml-rpc
%{summary}

%package gb-xml-libxml-xslt
Summary:	Gambas component package for xml.libxml.xslt
Group:		Development/Tools
Requires:	%{name}-runtime = %{version}-%{release}

%description gb-xml-libxml-xslt
%{summary}


%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1


%build
# Gambas can't deal with -Wp,-D_FORTIFY_SOURCE=2
CFLAGS=`echo $RPM_OPT_FLAGS | sed -e 's/-Wp,-D_FORTIFY_SOURCE=2//g'`

rm -f  $(find . -type f | egrep "Makefile$") $(find . -type f | egrep "Makefile.in$")
./reconf || echo reconf gives a warning but lets continue anyway
%configure \
	--datadir="%{_datadir}" \
	--enable-intl \
	--enable-conv \
	--enable-qt \
	--enable-kde \
	--enable-net \
	--enable-curl \
	--enable-postgresql \
	--enable-mysql \
	--enable-sqlite \
	--enable-sdl \
	--enable-vb
%{__make} %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
export PATH=$RPM_BUILD_ROOT/usr/bin:$PATH
make DESTDIR=$RPM_BUILD_ROOT install
# Yes, I know. Normally we'd nuke the .la files, but Gambas is retar^Wspecial.
# rm -rf $RPM_BUILD_ROOT%{_libdir}/gambas/*.la
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
install -m0644 ./app/gambas/.icon/32.png $RPM_BUILD_ROOT%{_datadir}/pixmaps/gambas.png
install src/share/gambas.h $RPM_BUILD_ROOT/%{_includedir}

desktop-file-install --vendor fedora			\
  --dir ${RPM_BUILD_ROOT}%{_datadir}/applications	\
  debian/gambas.desktop

# Pull buildroot out of the examples files
for i in `grep -lr "$RPM_BUILD_ROOT" $RPM_BUILD_ROOT%{_datadir}/%{name}/examples/`; 
do
  sed -i "s|$RPM_BUILD_ROOT||g" $i; 
done

%clean
rm -rf $RPM_BUILD_ROOT

%post 
/sbin/ldconfig
update-desktop-database %{_datadir}/applications &> /dev/null

%postun
/sbin/ldconfig
if [ "$1" = "0" ]; then
  update-desktop-database %{_datadir}/applications &> /dev/null
fi

%files runtime
%defattr(-, root, root, 0755)
%doc AUTHORS COPYING INSTALL README README.REDHAT TODO
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.component
%{_bindir}/gambas
%{_bindir}/gbi
%{_bindir}/gbx
%{_datadir}/pixmaps/gambas.png
%{_datadir}/applications/*.desktop
%dir %{_datadir}/gambas/
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.info
%{_datadir}/gambas/info/gb.list

%files ide
%defattr(-, root, root, 0755)
%{_bindir}/gbc
%{_bindir}/gba
%{_bindir}/gambas-database-manager
%{_includedir}/gambas.h
%{_datadir}/gambas/
%exclude %{_datadir}/gambas/info/

# For what its worth, I think this packaging layout is horrific.
# But, I'm going to play nice with upstream and let the user suffer.
# ~spot

%files gb-compress
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.compress.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.compress.*

%files gb-db
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.db.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.db.*

%files gb-debug
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.debug.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.debug.*

%files gb-eval
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.eval.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.eval.*

%files gb-net
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.net.component
%{_libdir}/gambas/lib.gb.net.so*
%{_libdir}/gambas/lib.gb.net.la
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.net.info
%{_datadir}/gambas/info/gb.net.list

%files gb-net-curl
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.net.curl.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.net.curl.*

%files gb-qt 
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas 
%{_libdir}/gambas/lib.gb.qt.component 
%{_libdir}/gambas/lib.gb.qt.so* 
%{_libdir}/gambas/lib.gb.qt.la 
%dir %{_datadir}/gambas/info 
%{_datadir}/gambas/info/gb.qt.info 
%{_datadir}/gambas/info/gb.qt.list

%files gb-qt-editor 
%defattr(-, root, root, 0755) 
%dir %{_libdir}/gambas 
%{_libdir}/gambas/lib.gb.qt.editor.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.editor.*

%files gb-qt-ext
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.qt.ext.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.ext.*

%files gb-qt-kde
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.qt.kde.component
%{_libdir}/gambas/lib.gb.qt.kde.so*
%{_libdir}/gambas/lib.gb.qt.kde.la
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.kde.info
%{_datadir}/gambas/info/gb.qt.kde.list

%files gb-qt-kde-html
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.qt.kde.html.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.qt.kde.html.*

%files gb-sdl
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.sdl.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.sdl.*

%files gb-vb
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.vb.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.vb.*

%files gb-xml-libxml
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.xml.libxml.component
%{_libdir}/gambas/lib.gb.xml.libxml.so*
%{_libdir}/gambas/lib.gb.xml.libxml.la
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.xml.libxml.info
%{_datadir}/gambas/info/gb.xml.libxml.list

%files gb-xml-libxml-rpc
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.xml.libxml.rpc.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.xml.libxml.rpc.*

%files gb-xml-libxml-xslt
%defattr(-, root, root, 0755)
%dir %{_libdir}/gambas
%{_libdir}/gambas/lib.gb.xml.libxml.xslt.*
%dir %{_datadir}/gambas/info
%{_datadir}/gambas/info/gb.xml.libxml.xslt.*

%changelog
* Wed Mar  4 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.0.19-10
- fix desktop file

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.0.19-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Feb 16 2009 Tom "spot" Callaway <tcallawa@redhat.com> - 1.0.19-8
- rebuild

* Wed Oct  1 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.0.19-7
- fix gcc4 patch to apply without fuzz

* Tue Feb 19 2008 Fedora Release Engineering <rel-eng@fedoraproject.org> - 1.0.19-6
- Autorebuild for GCC 4.3

* Sat Jan 26 2008 Alex Lancaster <alexlan[AT]fedoraproject org> - 1.0.19-5
- BuildRequires: kdelibs-devel -> kdelibs3-devel

* Sat Jan 26 2008 Alex Lancaster <alexlan[AT]fedoraproject org> - 1.0.19-4
- Rebuild for new gettext

* Mon Sep 24 2007 Jesse Keating <jkeating@redhat.com> - 1.0.19-3
- BuildRequire sqlite-devel instead of sqlite2-devel.

* Mon Sep 24 2007 Jesse Keating <jkeating@redhat.com> - 1.0.19-2
- Rebuild for new sqlite.

* Fri Aug 24 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.19-1.2
- ppc64 is a 64bit arch

* Fri Aug 24 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.19-1.1
- missing BR: bzip2-devel, libxslt-devel, libxml2-devel

* Thu Aug 23 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.19-1
- bump to 1.0.19
- fix license tag

* Tue Apr 10 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-8
- make the gambas-runtime package own /usr/share/gambas, since everything
  depends on it (resolves bugzilla 233789)

* Fri Jan  5 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-7
- rebuild to pickup new deps

* Wed Nov  1 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-6
- double quotes, not single quotes

* Wed Nov  1 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-5
- pull buildroot out of the examples files

* Tue Oct 31 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-4
- a spoooky halloween bump for development

* Sun Sep 10 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-3
- disable x86_64, code is not (and likely never will be) 64bit clean

* Sun Sep 10 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-2
- uploading the new tarball helps. idiot.

* Sun Sep 10 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.17-1
- bump to 1.0.17

* Mon Jul 10 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.16-2
- fix 64bit arches

* Fri Jul  7 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.16-1
- bump to 1.0.16

* Mon Apr 24 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.15-1
- bump to 1.0.15
- try to reenable non-x86 arches

* Tue Feb 28 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.14-2
- add BR: qt-devel

* Tue Feb 28 2006 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.14-1
- fix minor description typo
- bump for FC5
- go to 1.0.14

* Fri Dec  2 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.13-3
- fix description to resolve bugzilla 173998

* Fri Nov 18 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.13-2
- BR: curl-devel, SDL_mixer-devel

* Thu Nov 17 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.13-1
- bump to 1.0.13
- rework package to upstream standards

* Sun Sep  4 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.11-1
- bump to 1.0.11
- add gambas.desktop, gambas.png

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.9-2
- put in correct patch

* Fri Jul 29 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.9-1
- bump for 1.0.9

* Mon Jul 11 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.8-1
- bump for another new version

* Thu Jul  7 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.7-1
- bump for new version

* Mon Jul  4 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.6-3
- clean up BuildRequires
- remove doubling of README in %doc

* Fri Jul  1 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.6-2
- added ExcludeArch for x86_64 and ppc

* Mon May 23 2005 Tom "spot" Callaway <tcallawa@redhat.com> 1.0.6-1
- initial package for Fedora Extras (based on package by Dries Verachtert)
